=== added file 'AUTHORS'
--- AUTHORS	1970-01-01 00:00:00 +0000
+++ AUTHORS	2010-05-18 12:21:48 +0000
@@ -0,0 +1,15 @@
+Authors
+=======
+
+Niko Sams <niko.sams@gmail.com>
+
+- started the project
+- maintainer
+
+Milian Wolff <mail@milianw.de>
+
+- various contributions
+- comaintainer
+
+
+

=== modified file 'CMakeLists.txt'
--- CMakeLists.txt	2010-03-14 10:19:34 +0000
+++ CMakeLists.txt	2010-05-18 12:21:48 +0000
@@ -69,7 +69,7 @@
 set(kdevphplanguagesupport_PART_SRCS
     phplanguagesupport.cpp
     phpparsejob.cpp
-    #phphighlighting.cpp
+    phphighlighting.cpp
 )
 
 kde4_add_plugin(kdevphplanguagesupport ${kdevphplanguagesupport_PART_SRCS})
@@ -88,4 +88,5 @@
 install(TARGETS kdevphplanguagesupport DESTINATION ${PLUGIN_INSTALL_DIR})
 
 install(FILES kdevphpsupport.desktop DESTINATION ${SERVICES_INSTALL_DIR})
-install(FILES phpfunctions.php.gz DESTINATION ${DATA_INSTALL_DIR}/kdevphpsupport)
+# not writeable so that the refactoring actions get hidden
+install(FILES phpfunctions.php.gz DESTINATION ${DATA_INSTALL_DIR}/kdevphpsupport PERMISSIONS OWNER_READ GROUP_READ WORLD_READ)

=== modified file 'app_templates/simple_phpapp/simple_phpapp.kdevtemplate'
--- app_templates/simple_phpapp/simple_phpapp.kdevtemplate	2010-04-04 11:55:33 +0000
+++ app_templates/simple_phpapp/simple_phpapp.kdevtemplate	2010-05-18 12:21:48 +0000
@@ -3,10 +3,12 @@
 Name=Simple PHP Application
 Name[ca]=Aplicació PHP senzilla
 Name[ca@valencia]=Aplicació PHP senzilla
+Name[da]=Simpel PHP-applikation
 Name[en_GB]=Simple PHP Application
 Name[es]=Aplicación PHP sencilla
 Name[et]=Lihtne PHP rakendus
 Name[fr]=Application PHP simple
+Name[it]=Semplice applicazione in PHP
 Name[nds]=Eenfach PHP-Programm
 Name[nl]=Eenvoudig PHP-programma
 Name[pl]=Prosty program w PHP
@@ -22,10 +24,12 @@
 Comment=Generate filestructure to start a PHP application
 Comment[ca]=Genera l'estructura de fitxer per iniciar una aplicació PHP
 Comment[ca@valencia]=Genera l'estructura de fitxer per iniciar una aplicació PHP
+Comment[da]=Generér filstruktur til at starte en PHP-applikation
 Comment[en_GB]=Generate filestructure to start a PHP application
 Comment[es]=Generar una estructura de archivos para iniciar una aplicación PHP
 Comment[et]=Failistruktuuri genereerimine PHP rakenduse tarbeks
 Comment[fr]=Génère une structure de fichiers pour démarrer une application PHP
+Comment[it]=Genera la struttura dei file per iniziare un'applicazione in PHP
 Comment[nds]=Dateiopbuu för't Starten vun en PHP-Programm opstellen
 Comment[nl]=Een bestandsstructuur genereren om een PHP-programma te starten
 Comment[pl]=Generuje strukturę plików do uruchomienia programu w PHP

=== modified file 'completion/context.cpp'
--- completion/context.cpp	2010-03-14 10:19:34 +0000
+++ completion/context.cpp	2010-05-18 12:21:48 +0000
@@ -1400,7 +1400,7 @@
                     CodeModelItem::Kind k = foundItems[i].kind;
                     if (((k & CodeModelItem::Function) || (k & CodeModelItem::Variable)) && !(k & CodeModelItem::ClassMember)) {
                         foreach(const ParsingEnvironmentFilePointer &env, DUChain::self()->allEnvironmentFiles(url)) {
-                            if (env->language() != IndexedString("Php")) continue;
+                            if (env->language() != phpLangString) continue;
                             TopDUContext* top = env->topContext();
                             if(!top) continue;
                             if (m_duContext->imports(top)) continue;
@@ -1442,7 +1442,7 @@
                         if (!(foundItems[i].kind & CompletionCodeModelItem::Exception)) continue;
                     }
                     foreach(const ParsingEnvironmentFilePointer &env, DUChain::self()->allEnvironmentFiles(url)) {
-                        Q_ASSERT(env->language() == IndexedString("Php"));
+                        Q_ASSERT(env->language() == phpLangString);
                         items << CompletionTreeItemPointer ( new CodeModelCompletionItem(env, foundItems[i]));
                     }
                 }
@@ -1572,8 +1572,8 @@
 
     static DUChainPointer<ClassDeclaration> exceptionDecl;
     if (!exceptionDecl) {
-        QList<Declaration*> decs = dec->context()->findDeclarations(QualifiedIdentifier("exception"));
-        Q_ASSERT(decs.count() == 1);
+        QList<Declaration*> decs = dec->context()->findDeclarations(exceptionQId);
+        Q_ASSERT(decs.count());
         exceptionDecl = dynamic_cast<ClassDeclaration*>(decs.first());
         Q_ASSERT(exceptionDecl);
     }

=== modified file 'completion/model.cpp'
--- completion/model.cpp	2010-02-17 22:20:31 +0000
+++ completion/model.cpp	2010-05-18 12:21:48 +0000
@@ -90,8 +90,10 @@
 
 bool CodeCompletionModel::shouldAbortCompletion(View* view, const SmartRange &range, const QString &currentCompletion)
 {
-    Q_UNUSED(view);
-    Q_UNUSED(range);
+    if(view->cursorPosition() < range.start() || view->cursorPosition() > range.end())
+        return true; //Always abort when the completion-range has been left
+    //Do not abort completions when the text has been empty already before and a newline has been entered
+
     static const QRegExp allowedText("^\\$?(\\w*)");
     return !allowedText.exactMatch(currentCompletion);
 }

=== modified file 'create_functions.php'
--- create_functions.php	2010-03-14 10:19:34 +0000
+++ create_functions.php	2010-05-18 12:21:48 +0000
@@ -35,6 +35,7 @@
 $skipClasses[] = 'parent';
 $skipClasses[] = '__php_incomplete_class';
 $skipClasses[] = 'php_user_filter';
+$skipClasses[] = 'static'; // O_o where does that come from?
 
 ///TODO: re-enable them once they have their do(), echo() or list() methods removed.
 $skipClasses[] = 'gearmanclient';
@@ -74,6 +75,7 @@
 
     $dirs = array(
         $_SERVER['argv'][1]."/reference",
+        $_SERVER['argv'][1]."/features",
         $_SERVER['argv'][1]."/appendices",
         $_SERVER['argv'][1]."/language/predefined/"
     );
@@ -146,6 +148,10 @@
     // remove <para> and other stuff
     ///TODO: support web-links, lists and tables
     $comment = strip_tags($comment);
+    $comment = html_entity_decode($comment);
+
+    // make sure no */ occurs in a comment...
+    $comment = preg_replace('#\*/#', '* /', $comment);
 
     $comment = preg_replace('#(?<=[^\n])\n(?=[^\n])#s', ' ', $comment);
 
@@ -368,7 +374,6 @@
     if (substr($file->getFilename(), -4) != '.xml') return false;
     if (substr($file->getFilename(), 0, 9) == 'entities.') return false;
     $string = file_get_contents($file->getPathname());
-    $string = preg_replace('#<!\\[CDATA\\[.*?\\]\\]>#s', '', $string);
     $isInterface = strpos($string, '<phpdoc:classref') !== false &&
                    strpos($string, '&reftitle.interfacesynopsis;') !== false;
 
@@ -380,7 +385,7 @@
         $string = preg_replace('#'.preg_quote('<section xml:id="'.$i.'">').'.*?</section>#s', '', $string);
     }
     echo "reading documentation from {$file->getPathname()}\n";
-    $xml = new SimpleXMLElement($string);
+    $xml = simplexml_load_string($string,  "SimpleXMLElement",  LIBXML_NOCDATA);
 
     if ( $file->getFilename() == 'versions.xml' ) {
         foreach ( $xml->xpath('/versions/function') as $f ) {
@@ -447,7 +452,7 @@
                     // check for comment
                     // next entry is the value of the constant which is followed by the comment
                     if ( isset($consts[$i+2]) && !$consts[$i+2]->children() ) {
-                        $comment = (string)$consts[$i+2];
+                        $comment = $consts[$i+2]->asXml();
                         if ( !empty($comment) ) {
                             $constants_comments[(string)$p->constant] = $comment;
                         }
@@ -456,6 +461,32 @@
                 $constants[(string)$p->constant] = (string)$p->type;
             }
         }
+    } else if (!isset($xml->variablelist) && $file->getFilename() == 'commandline.xml') {
+        // yay for non-unified xml structures :-X
+        $consts = $xml->xpath("//db:row");
+        foreach ( $consts as $i=>$p ) {
+            $constant = "";
+                    // default to integer constants
+            $type = "integer";
+            if ( isset($p->entry[0]) && isset($p->entry[0]->constant) ) {
+                $constant = trim((string) $p->entry[0]->constant);
+                if ( isset($p->entry[0]->constant->type) ) {
+                    $type = (string)$p->entry[0]->constant->type;
+                }
+            }
+            if (empty($constant)) {
+                continue;
+            }
+            // check for comment
+            // next entry is the comment
+            if ( isset($p->entry[1]) ) {
+                $comment = $p->entry[1]->para->asXml();
+                if ( !empty($comment) ) {
+                    $constants_comments[$constant] = $comment;
+                }
+            }
+            $constants[$constant] = $type;
+        }
     }
     if ($list = $xml->xpath('//db:sect2[starts-with(@xml:id, "reserved.classes")]/db:variablelist/db:varlistentry')) {
         foreach ($list as $l) {

=== modified file 'duchain/builders/contextbuilder.cpp'
--- duchain/builders/contextbuilder.cpp	2010-03-14 10:19:34 +0000
+++ duchain/builders/contextbuilder.cpp	2010-05-18 12:21:48 +0000
@@ -129,7 +129,7 @@
 {
     if (!file) {
         file = new ParsingEnvironmentFile(editor()->currentUrl());
-        file->setLanguage(IndexedString("Php"));
+        file->setLanguage(phpLangString);
     }
     TopDUContext* ret = new PhpDUContext<TopDUContext>(editor()->currentUrl(), range, file);
     return ret;

=== modified file 'duchain/builders/declarationbuilder.cpp'
--- duchain/builders/declarationbuilder.cpp	2010-03-14 10:19:34 +0000
+++ duchain/builders/declarationbuilder.cpp	2010-05-18 12:21:48 +0000
@@ -199,7 +199,7 @@
     DUChainWriteLocker lock(DUChain::lock());
     while (curClass->baseClassesSize() > 0) {
         StructureType::Ptr type;
-        FOREACH_FUNCTION(BaseClassInstance base, curClass->baseClasses) {
+        FOREACH_FUNCTION(const BaseClassInstance& base, curClass->baseClasses) {
             DUChainReadLocker lock(DUChain::lock());
             type = base.baseClass.type<StructureType>();
             if (!type) {
@@ -650,7 +650,7 @@
                                             AstNode* node)
 {
     // we must not re-assign $this in a class context
-    if ( identifier == QualifiedIdentifier("this")
+    if ( identifier == thisQId
             && currentContext()->parentContext()
             && currentContext()->parentContext()->type() == DUContext::Class ) {
         reportError(i18n("Cannot re-assign $this."), QList<AstNode*>() << node);
@@ -737,7 +737,7 @@
 }
 
 DUContext* getClassContext(const QualifiedIdentifier &identifier, DUContext* currentCtx) {
-    if ( identifier == QualifiedIdentifier("this") ) {
+    if ( identifier == thisQId ) {
         if ( currentCtx->parentContext() && currentCtx->parentContext()->type() == DUContext::Class ) {
             return currentCtx->parentContext();
         }

=== modified file 'duchain/builders/typebuilder.cpp'
--- duchain/builders/typebuilder.cpp	2010-03-14 10:19:34 +0000
+++ duchain/builders/typebuilder.cpp	2010-05-18 12:21:48 +0000
@@ -480,12 +480,12 @@
             Q_ASSERT(classDec);
             lock.unlock();
             ClassDeclaration* iteratorDecl = dynamic_cast<ClassDeclaration*>(
-                findDeclarationImport(ClassDeclarationType, QualifiedIdentifier("iterator"), 0)
+                findDeclarationImport(ClassDeclarationType, iteratorQId, 0)
             );
             lock.lock();
             Q_ASSERT(iteratorDecl);
             if (classDec->isPublicBaseClass(iteratorDecl, currentContext()->topContext())) {
-                foreach (Declaration *d, classDec->internalContext()->findDeclarations(QualifiedIdentifier("current"))) {
+                foreach (Declaration *d, classDec->internalContext()->findDeclarations(currentQId)) {
                     if (!dynamic_cast<ClassMethodDeclaration*>(d)) continue;
                     Q_ASSERT(d->type<FunctionType>());
                     injectType(d->type<FunctionType>()->returnType());

=== modified file 'duchain/declarations/classdeclaration.cpp'
--- duchain/declarations/classdeclaration.cpp	2010-03-14 10:19:34 +0000
+++ duchain/declarations/classdeclaration.cpp	2010-05-18 12:21:48 +0000
@@ -23,6 +23,8 @@
 #include <language/duchain/duchainregister.h>
 #include <completioncodemodel.h>
 
+#include "helper.h"
+
 namespace Php {
 REGISTER_DUCHAIN_ITEM(ClassDeclaration);
 
@@ -109,13 +111,13 @@
     if(!d_func()->prettyName.isEmpty()) {
         if(!d_func()->m_inSymbolTable && inSymbolTable) {
             CompletionCodeModelItem::Kind flags = CompletionCodeModelItem::Unknown;
-            if (qualifiedIdentifier() == KDevelop::QualifiedIdentifier("exception")) {
+            if (qualifiedIdentifier() == exceptionQId) {
                 flags = (CompletionCodeModelItem::Kind)(flags | CompletionCodeModelItem::Exception);
             } else {
                 static KDevelop::DUChainPointer<ClassDeclaration> exceptionDecl;
                 if (!exceptionDecl) {
-                    QList<Declaration*> decs = context()->topContext()->findDeclarations(KDevelop::QualifiedIdentifier("exception"));
-                    Q_ASSERT(decs.count() == 1);
+                    QList<Declaration*> decs = context()->topContext()->findDeclarations(exceptionQId);
+                    Q_ASSERT(decs.count());
                     exceptionDecl = dynamic_cast<ClassDeclaration*>(decs.first());
                     Q_ASSERT(exceptionDecl);
                 }

=== modified file 'duchain/expressionvisitor.cpp'
--- duchain/expressionvisitor.cpp	2010-03-14 10:19:34 +0000
+++ duchain/expressionvisitor.cpp	2010-05-18 12:21:48 +0000
@@ -512,7 +512,7 @@
             break;
         case CastObject: {
             DUChainReadLocker lock(DUChain::lock());
-            m_result.setDeclarations(m_currentContext->findDeclarations(QualifiedIdentifier("stdclass")));
+            m_result.setDeclarations(m_currentContext->findDeclarations(stdclassQId));
             break;
         }
         case CastBool:

=== modified file 'duchain/helper.cpp'
--- duchain/helper.cpp	2010-03-14 10:19:34 +0000
+++ duchain/helper.cpp	2010-05-18 12:21:48 +0000
@@ -78,13 +78,13 @@
         DeclarationType declarationType, AstNode* node, EditorIntegrator* editor)
 {
     ifDebug(kDebug() << id.toString() << declarationType;)
-    if (declarationType == ClassDeclarationType && id == QualifiedIdentifier("self")) {
+    if (declarationType == ClassDeclarationType && id == selfQId) {
         DUChainReadLocker lock(DUChain::lock());
         if (currentContext->parentContext()) {
             Declaration* declaration = currentContext->parentContext()->owner();
             return declaration;
         }
-    } else if (declarationType == ClassDeclarationType && id == QualifiedIdentifier("parent")) {
+    } else if (declarationType == ClassDeclarationType && id == parentQId) {
         //there can be just one Class-Context imported
         DUChainReadLocker lock(DUChain::lock());
         if (currentContext->parentContext()) {
@@ -122,7 +122,7 @@
                     ifDebug(kDebug() << "skipping declaration, missing meta-data";)
                     continue;
                 }
-                if(env->language() != IndexedString("Php")) {
+                if(env->language() != phpLangString) {
                     ifDebug(kDebug() << "skipping declaration, invalid language" << env->language().str();)
                     continue;
                 }

=== modified file 'duchain/helper.h'
--- duchain/helper.h	2010-02-17 22:20:31 +0000
+++ duchain/helper.h	2010-05-18 12:21:48 +0000
@@ -44,6 +44,24 @@
     ConstantDeclarationType,
     GlobalVariableDeclarationType
 };
+
+/// Indexed string for 'Php', identifies environment files from this language plugin
+const KDevelop::IndexedString phpLangString("Php");
+/// Qualified identifier for 'this'
+const KDevelop::QualifiedIdentifier thisQId("this");
+/// Qualified identifier for 'exception'
+const KDevelop::QualifiedIdentifier exceptionQId("exception");
+/// Qualified identifier for 'iterator'
+const KDevelop::QualifiedIdentifier iteratorQId("iterator");
+/// Qualified identifier for 'stdclass'
+const KDevelop::QualifiedIdentifier stdclassQId("stdclass");
+/// Qualified identifier for 'self'
+const KDevelop::QualifiedIdentifier selfQId("self");
+/// Qualified identifier for 'parent'
+const KDevelop::QualifiedIdentifier parentQId("parent");
+/// Qualified identifier for 'current'
+const KDevelop::QualifiedIdentifier currentQId("current");
+
 KDEVPHPDUCHAIN_EXPORT bool isMatch(KDevelop::Declaration* declaration, DeclarationType declarationType);
 
 KDEVPHPDUCHAIN_EXPORT KDevelop::Declaration* findDeclarationImportHelper(KDevelop::DUContext* currentContext,

=== modified file 'kdevphpsupport.desktop'
--- kdevphpsupport.desktop	2010-04-04 11:55:33 +0000
+++ kdevphpsupport.desktop	2010-05-18 12:21:48 +0000
@@ -5,11 +5,13 @@
 Comment=Php Language Support
 Comment[ca]=Implementació del llenguatge Php
 Comment[ca@valencia]=Implementació del llenguatge Php
+Comment[da]=PHP-sprogunderstøttelse
 Comment[en_GB]=Php Language Support
 Comment[es]=Implementación de lenguaje PHP
 Comment[et]=PHP keele toetus
 Comment[fr]=Prise en charge du langage PHP
 Comment[ga]=Tacaíocht PHP
+Comment[it]=Supporto al linguaggio PHP
 Comment[nds]=Ünnerstütten för PHP
 Comment[nl]=Ondersteuning voor PHP-taal
 Comment[pl]=Obsługa języka PHP
@@ -24,12 +26,14 @@
 Name=KDevPhpSupport
 Name[ca]=KDevPhpSupport
 Name[ca@valencia]=KDevPhpSupport
+Name[da]=KDevPhpSupport
 Name[de]=KDevPhpSupport
 Name[en_GB]=KDevPhpSupport
 Name[es]=KDevPhpSupport
 Name[et]=KDevPhpSupport
 Name[fr]=KDevPhpSupport
 Name[ga]=KDevPhpSupport
+Name[it]=KDevPhpSupport
 Name[nds]=KDevelop-Ünnerstütten för PHP
 Name[nl]=KDevPhpSupport
 Name[pl]=KDevPhpSupport
@@ -44,11 +48,13 @@
 GenericName[ca]=Implementació de Php
 GenericName[ca@valencia]=Implementació de Php
 GenericName[cs]=Podpora php
+GenericName[da]=PHP-understøttelse
 GenericName[en_GB]=Php Support
 GenericName[es]=Implementación de PHP
 GenericName[et]=PHP toetus
 GenericName[fr]=Prise en charge de PHP
 GenericName[ga]=Tacaíocht PHP
+GenericName[it]=Supporto PHP
 GenericName[nds]=PHP-Ünnerstütten
 GenericName[nl]=Ondersteuning voor PHP
 GenericName[pl]=Obsługa PHP
@@ -63,7 +69,7 @@
 ServiceTypes=KDevelop/Plugin
 Icon=application-x-php
 X-KDE-Library=kdevphplanguagesupport
-X-KDevelop-Version=8
+X-KDevelop-Version=9
 X-KDevelop-Language=Php
 X-KDevelop-Args=PHP
 X-KDevelop-Interfaces=ILanguageSupport

=== modified file 'parser/generated/phpast.h'
--- parser/generated/phpast.h	2010-02-17 22:20:31 +0000
+++ parser/generated/phpast.h	2010-05-18 12:21:48 +0000
@@ -985,7 +985,7 @@
     ElseifListAst *elseifList;
     ElseSingleAst *elseSingle;
     ExprAst *whileExpr;
-    WhileStatementAst *whilteStatement;
+    WhileStatementAst *whileStatement;
     ForExprAst *forExpr1;
     ForExprAst *forExpr2;
     ForExprAst *forExpr3;
@@ -1003,7 +1003,6 @@
     const KDevPG::ListNode<VariableAst *> *unsetVariablesSequence;
     ExprAst *expr;
     StatementAst *doStatement;
-    ExprAst *whilteExpr;
     ExprAst *breakExpr;
     ExprAst *continueExpr;
     ExprAst *returnExpr;

=== modified file 'parser/generated/phpdebugvisitor.h'
--- parser/generated/phpdebugvisitor.h	2010-02-17 22:20:31 +0000
+++ parser/generated/phpdebugvisitor.h	2010-05-18 12:21:48 +0000
@@ -1119,7 +1119,7 @@
         if (node->elseifList) printToken(node->elseifList, "elseifList", "elseifList");
         if (node->elseSingle) printToken(node->elseSingle, "elseSingle", "elseSingle");
         if (node->whileExpr) printToken(node->whileExpr, "expr", "whileExpr");
-        if (node->whilteStatement) printToken(node->whilteStatement, "whileStatement", "whilteStatement");
+        if (node->whileStatement) printToken(node->whileStatement, "whileStatement", "whileStatement");
         if (node->forExpr1) printToken(node->forExpr1, "forExpr", "forExpr1");
         if (node->forExpr2) printToken(node->forExpr2, "forExpr", "forExpr2");
         if (node->forExpr3) printToken(node->forExpr3, "forExpr", "forExpr3");
@@ -1155,7 +1155,6 @@
         }
         if (node->expr) printToken(node->expr, "expr", "expr");
         if (node->doStatement) printToken(node->doStatement, "statement", "doStatement");
-        if (node->whilteExpr) printToken(node->whilteExpr, "expr", "whilteExpr");
         if (node->breakExpr) printToken(node->breakExpr, "expr", "breakExpr");
         if (node->continueExpr) printToken(node->continueExpr, "expr", "continueExpr");
         if (node->returnExpr) printToken(node->returnExpr, "expr", "returnExpr");

=== modified file 'parser/generated/phpdefaultvisitor.cpp'
--- parser/generated/phpdefaultvisitor.cpp	2010-02-17 22:20:31 +0000
+++ parser/generated/phpdefaultvisitor.cpp	2010-05-18 12:21:48 +0000
@@ -761,7 +761,7 @@
     visitNode(node->elseifList);
     visitNode(node->elseSingle);
     visitNode(node->whileExpr);
-    visitNode(node->whilteStatement);
+    visitNode(node->whileStatement);
     visitNode(node->forExpr1);
     visitNode(node->forExpr2);
     visitNode(node->forExpr3);
@@ -797,7 +797,6 @@
     }
     visitNode(node->expr);
     visitNode(node->doStatement);
-    visitNode(node->whilteExpr);
     visitNode(node->breakExpr);
     visitNode(node->continueExpr);
     visitNode(node->returnExpr);

=== modified file 'parser/generated/phpparser.cpp'
--- parser/generated/phpparser.cpp	2010-02-17 22:20:31 +0000
+++ parser/generated/phpparser.cpp	2010-05-18 12:21:48 +0000
@@ -9179,7 +9179,7 @@
                 }
                 return false;
             }
-            (*yynode)->whilteStatement = __node_182;
+            (*yynode)->whileStatement = __node_182;
 
         }
         else if (yytoken == Token_FOR)
@@ -9823,7 +9823,7 @@
                 }
                 return false;
             }
-            (*yynode)->whilteExpr = __node_206;
+            (*yynode)->whileExpr = __node_206;
 
             if (yytoken != Token_RPAREN)
             {

=== modified file 'parser/generated/phpparser.h'
--- parser/generated/phpparser.h	2010-01-17 17:10:22 +0000
+++ parser/generated/phpparser.h	2010-05-18 12:21:48 +0000
@@ -52,8 +52,6 @@
     }
 
 // memory pool
-    typedef KDevPG::MemoryPool memoryPoolType;
-
     KDevPG::MemoryPool *memoryPool;
     void setMemoryPool(KDevPG::MemoryPool *p)
     {

=== modified file 'parser/php.g'
--- parser/php.g	2010-02-17 22:20:31 +0000
+++ parser/php.g	2010-05-18 12:21:48 +0000
@@ -37,6 +37,19 @@
 -- 1 first/follow conflicts:
 --  - elseifList: dangling-else conflict - should be ok
 
+-- TODO: (post 1.0.0 release)
+--  1) decrease memory consumption
+--    1.1) use quint32 instead of qint64 for end/start tokens
+--    1.2) investigate whether using a map/hash for the ducontext member of all
+--         ast nodes gives a significant memory decrease while not hampering performance
+--    1.3) investigate how unions could be used for exclusive AST node members
+--    1.4) see whether we can always use the expression lists instead of both
+--         single member pointer and list of members, esp. in expressions
+--  2) better cope with invalid code, have at least a partial AST
+--  3) investigate whether expanding the visitor lookup to a
+--     (albeit huge) switch() in KDev-PG-Qt gives a significant performance gain
+--     I have the gut feeling that the current lookup takes unneccessary much time
+--
 
 [:
 
@@ -575,7 +588,7 @@
       (   COLON statements=innerStatementList newElseifList newElseSingle ENDIF semicolonOrCloseTag
         | ifStatement=statement elseifList=elseifList elseSingle=elseSingle
       )
-  | WHILE LPAREN whileExpr=expr RPAREN whilteStatement=whileStatement
+  | WHILE LPAREN whileExpr=expr RPAREN whileStatement=whileStatement
   | FOR LPAREN forExpr1=forExpr SEMICOLON forExpr2=forExpr
     SEMICOLON forExpr3=forExpr RPAREN forStatement=forStatement
   | SWITCH LPAREN swtichExpr=expr RPAREN switchCaseList=switchCaseList
@@ -592,7 +605,7 @@
     #catches=catchItem*
   | UNSET LPAREN #unsetVariables=variable @ COMMA RPAREN semicolonOrCloseTag
   | expr=expr semicolonOrCloseTag
-  | DO doStatement=statement WHILE LPAREN whilteExpr=expr RPAREN semicolonOrCloseTag
+  | DO doStatement=statement WHILE LPAREN whileExpr=expr RPAREN semicolonOrCloseTag
   | BREAK (breakExpr=expr | 0) semicolonOrCloseTag
   | CONTINUE (continueExpr=expr | 0) semicolonOrCloseTag
   | RETURN (returnExpr=expr | 0) semicolonOrCloseTag

=== modified file 'phpfunctions.php.gz'
Binary files phpfunctions.php.gz and phpfunctions.php.gz differ
=== added file 'phphighlighting.cpp'
--- phphighlighting.cpp	1970-01-01 00:00:00 +0000
+++ phphighlighting.cpp	2010-05-18 12:21:48 +0000
@@ -0,0 +1,94 @@
+/*
+    <one line to give the program's name and a brief idea of what it does.>
+    Copyright (C) <year>  <name of author>
+
+    This program is free software: you can redistribute it and/or modify
+    it under the terms of the GNU General Public License as published by
+    the Free Software Foundation, either version 3 of the License, or
+    (at your option) any later version.
+
+    This program is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU General Public License for more details.
+
+    You should have received a copy of the GNU General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+*/
+
+#include "phphighlighting.h"
+#include <language/duchain/declaration.h>
+#include <language/duchain/use.h>
+#include <language/highlighting/colorcache.h>
+#include <language/highlighting/configurablecolors.h>
+
+#include <KTextEditor/SmartRange>
+#include <KTextEditor/SmartInterface>
+#include <KTextEditor/Document>
+
+using namespace KDevelop;
+using namespace Php;
+using namespace KTextEditor;
+
+#define LOCK_SMART(range) KTextEditor::SmartInterface* iface = dynamic_cast<KTextEditor::SmartInterface*>(range->document()); QMutexLocker lock(iface ? iface->smartMutex() : 0);
+
+class HighlightingInstance : public CodeHighlightingInstance {
+public:
+    HighlightingInstance(const CodeHighlighting* highlighting);
+    virtual void highlightDeclaration(Declaration* declaration, const QColor& color) const;
+    virtual void highlightUse(DUContext* context, int index, const QColor& color) const;
+
+};
+
+HighlightingInstance::HighlightingInstance(const CodeHighlighting* highlighting)
+    : CodeHighlightingInstance(highlighting)
+{
+}
+
+bool isConstDeclaration(Declaration* decl) {
+    return decl && !decl->isFunctionDeclaration() &&
+           decl->abstractType() && decl->abstractType()->modifiers() & AbstractType::ConstModifier;
+}
+
+///TODO: make this easier by rewriting some parts in the KDevplatform CodeHighlightingInstance
+///      essentially we'd need to overwrite TypeForDeclaration
+void HighlightingInstance::highlightDeclaration(Declaration* declaration, const QColor& color) const
+{
+    if (isConstDeclaration(declaration)) {
+        // highlight const class members and defines differently from normal variables
+        if (SmartRange* range = declaration->smartRange()) {
+            LOCK_SMART(range);
+            range->setAttribute(m_highlighting->attributeForType(EnumType, DeclarationContext, color));
+        }
+    } else {
+        CodeHighlightingInstance::highlightDeclaration(declaration, color);
+    }
+}
+
+///TODO: make this easier by rewriting some parts in the KDevplatform CodeHighlightingInstance
+///      essentially we'd need to overwrite TypeForDeclaration
+void HighlightingInstance::highlightUse(DUContext* context, int index, const QColor& color) const
+{
+    if (SmartRange* range = context->useSmartRange(index)) {
+        Declaration* decl = context->topContext()->usedDeclarationForIndex(context->uses()[index].m_declarationIndex);
+        if (isConstDeclaration(decl)) {
+            LOCK_SMART(range);
+            range->setAttribute(m_highlighting->attributeForType(EnumType, ReferenceContext, color));
+            return;
+        }
+    }
+    KDevelop::CodeHighlightingInstance::highlightUse(context, index, color);
+}
+
+
+Highlighting::Highlighting(QObject* parent)
+    : CodeHighlighting(parent)
+{
+
+}
+
+CodeHighlightingInstance* Highlighting::createInstance() const
+{
+    return new HighlightingInstance(this);
+}

=== added file 'phphighlighting.h'
--- phphighlighting.h	1970-01-01 00:00:00 +0000
+++ phphighlighting.h	2010-05-18 12:21:48 +0000
@@ -0,0 +1,37 @@
+/*
+    <one line to give the program's name and a brief idea of what it does.>
+    Copyright (C) <year>  <name of author>
+
+    This program is free software: you can redistribute it and/or modify
+    it under the terms of the GNU General Public License as published by
+    the Free Software Foundation, either version 3 of the License, or
+    (at your option) any later version.
+
+    This program is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU General Public License for more details.
+
+    You should have received a copy of the GNU General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+*/
+
+#ifndef PHP_PHPHIGHLIGHTING_H
+#define PHP_PHPHIGHLIGHTING_H
+
+#include <language/highlighting/codehighlighting.h>
+
+
+namespace Php {
+
+class Highlighting : public KDevelop::CodeHighlighting
+{
+public:
+    Highlighting(QObject* parent);
+    virtual KDevelop::CodeHighlightingInstance* createInstance() const;
+};
+
+}
+
+#endif // PHP_PHPHIGHLIGHTING_H

=== modified file 'phplanguagesupport.cpp'
--- phplanguagesupport.cpp	2010-03-14 10:19:34 +0000
+++ phplanguagesupport.cpp	2010-05-18 12:21:48 +0000
@@ -42,11 +42,11 @@
 #include <interfaces/idocumentcontroller.h>
 
 #include "phpparsejob.h"
-//#include "phphighlighting.h"
+#include "phphighlighting.h"
 
 #include <language/codecompletion/codecompletion.h>
 #include <language/codecompletion/codecompletionmodel.h>
-#include <language/highlighting/codehighlighting.h>
+
 #include "completion/model.h"
 #include "completion/worker.h"
 
@@ -54,11 +54,12 @@
 #include <language/duchain/parsingenvironment.h>
 
 #include "duchain/helper.h"
+#include <QTimer>
 
 using namespace KDevelop;
 
 K_PLUGIN_FACTORY(KDevPhpSupportFactory, registerPlugin<Php::LanguageSupport>();)
-K_EXPORT_PLUGIN(KDevPhpSupportFactory(KAboutData("kdevphpsupport","kdevphp", ki18n("Php Support"), "1.0 Beta 4", ki18n("Support for Php Language"), KAboutData::License_GPL)
+K_EXPORT_PLUGIN(KDevPhpSupportFactory(KAboutData("kdevphpsupport","kdevphp", ki18n("Php Support"), "1.0.0", ki18n("Support for Php Language"), KAboutData::License_GPL)
     .addAuthor(ki18n("Milian Wolff"), ki18n("Author"), "mail@milianw.de", "http://milianw.de")
     .addAuthor(ki18n("Niko Sams"), ki18n("Author"), "niko.sams@gmail.com", "http://nikosams.blogspot.com")
 ))
@@ -80,13 +81,12 @@
 
     m_self = this;
 
-    m_highlighting = new KDevelop::CodeHighlighting(this);
+    m_highlighting = new Php::Highlighting(this);
 
     CodeCompletionModel* ccModel = new CodeCompletionModel(this);
     new KDevelop::CodeCompletion(this, ccModel, name());
 
-    connect(core()->pluginController(), SIGNAL(pluginLoaded(KDevelop::IPlugin*)),
-            this, SLOT(slotPluginLoaded(KDevelop::IPlugin*)));
+    QTimer::singleShot(0, this, SLOT(updateInternalFunctions()));
 }
 
 LanguageSupport::~LanguageSupport()
@@ -99,14 +99,11 @@
     }
 }
 
-void LanguageSupport::slotPluginLoaded( IPlugin* plugin )
+void LanguageSupport::updateInternalFunctions()
 {
-    if ( plugin == this ) {
-        kDebug() << "making sure that internal function file is up to date";
-        DUChain::self()->updateContextForUrl(internalFunctionFile(), KDevelop::TopDUContext::AllDeclarationsAndContexts, this, -10);
-        disconnect(core()->pluginController(), SIGNAL(pluginLoaded(KDevelop::IPlugin*)),
-                   this, SLOT(slotPluginLoaded(KDevelop::IPlugin*)));
-    }
+    Q_ASSERT(core()->pluginController()->loadedPlugins().contains(this));
+    kDebug() << "making sure that internal function file is up to date";
+    DUChain::self()->updateContextForUrl(internalFunctionFile(), KDevelop::TopDUContext::AllDeclarationsAndContexts, this, -10);
 }
 
 void LanguageSupport::updateReady( IndexedString url, ReferencedTopDUContext topContext )

=== modified file 'phplanguagesupport.h'
--- phplanguagesupport.h	2010-02-17 22:20:31 +0000
+++ phplanguagesupport.h	2010-05-18 12:21:48 +0000
@@ -120,7 +120,7 @@
     void updateReady(KDevelop::IndexedString url, KDevelop::ReferencedTopDUContext topContext);
 
 private slots:
-    void slotPluginLoaded(KDevelop::IPlugin* plugin);
+    void updateInternalFunctions();
 
 private:
     KDevelop::CodeHighlighting* m_highlighting;

=== modified file 'phpparsejob.cpp'
--- phpparsejob.cpp	2010-03-14 10:19:34 +0000
+++ phpparsejob.cpp	2010-05-18 12:21:48 +0000
@@ -290,7 +290,7 @@
         } else {
             DUChainWriteLocker lock(DUChain::lock());
             ParsingEnvironmentFile *file = new ParsingEnvironmentFile(document());
-            file->setLanguage(IndexedString("Php"));
+            file->setLanguage(phpLangString);
             top = new TopDUContext(document(), SimpleRange(SimpleCursor(0, 0), SimpleCursor(INT_MAX, INT_MAX)), file);
             DUChain::self()->addDocumentChain(top);
         }

